Update Cards in landing.block.updateCards

If you are developing integrations for Bitrix24 using AI tools (Codex, Claude Code, Cursor), connect to the MCP server so that the assistant can utilize the official REST documentation.

Scope: landing

Who can execute the method: a user with "edit" access permission for the site

The method landing.block.updateCards updates a set of cards in a block and the nodes within those cards in the draft of the page.

This method works with cards described in the cards key of the block manifest. If the page is already published, changes will be visible to visitors after publication through the interface or by using the landing.landing.publication method.

Method Parameters

Required parameters are marked with *

Name
type

Description

scope
string

Internal scope of landings. It is not related to the REST scope landing in the method name.

The value of scope must correspond to the type of site (detailed description)

lid*
integer

Identifier of the page.

The page identifier can be obtained using the landing.landing.getlist method

block*
integer

Identifier of the block in the draft of the page.

The block identifier can be obtained using the landing.block.getlist method with the parameter params.edit_mode = 1

data*
object

Set of changes for the block cards (detailed description)

Parameter data

Key
type

Description


object

Card selector from the cards section of the block manifest.

The value describes the final set of cards for this selector and the changes to their nodes (detailed description).

To find available card selectors and presets for a specific block, retrieve the manifest using the landing.block.getmanifest method

Object

Name
type

Description

source
array

Defines the final order and number of cards (detailed description)

values
array

Updates nodes within cards after applying source (detailed description)

Element of the source array

Name
type

Description

type
string

Type of the card source.

Possible values:
card - take the current card by index,
preset - create a card from a preset in manifest.cards.<selector>.presets.

Default - card

value
integer | string

Value of the card source.

For card, this is the index of the current card by selector, starting from 0.

For preset, this is the preset code from the block manifest

If the source element does not contain type, the method uses the value card. If value is not provided, the method uses index 0.

To create a new card from a preset, specify type with the value preset and pass the preset code from the block manifest in value. For example:

"source": [
          {
            "type": "card",
            "value": 0
          },
          {
            "type": "preset",
            "value": "preset_code"
          }
        ]
        

Element of the values array

Each element of the values array must be an object that contains one or more node changes.

Key
type

Description

@
string | object | array

Node selector within the card with position indicated by @.

The position is numbered from 0 and indicates which card to modify the node in after applying source.

The format of the value is the same as the data parameter in the landing.block.updatenodes method.

One object in the values array can contain multiple keys for different nodes and positions

If an element of the values array is not an object, the method will skip it without error. For example, in one element of the array, you can change multiple cards at once:

"values": [
          {
            ".landing-block-node-title@0": "First Card",
            ".landing-block-node-title@1": "Card from Preset"
          }
        ]
        

For detailed information on value formats for different node types, refer to the article landing.block.updatenodes and the overview Node Types.

Code Examples

How to Use Examples in Documentation

curl -X POST \
          -H "Content-Type: application/json" \
          -d '{
            "lid": 311,
            "block": 6058,
            "data": {
              ".landing-block-card": {
                "source": [
                  {
                    "type": "card",
                    "value": 0
                  },
                  {
                    "type": "preset",
                    "value": "preset_code"
                  }
                ],
                "values": [
                  {
                    ".landing-block-node-title@0": "First Card",
                    ".landing-block-node-title@1": "Card from Preset"
                  }
                ]
              }
            }
          }' \
          "https://**put.your-domain-here**/rest/**user_id**/**webhook_code**/landing.block.updateCards.json"
        
curl -X POST \
          -H "Content-Type: application/json" \
          -d '{
            "lid": 311,
            "block": 6058,
            "data": {
              ".landing-block-card": {
                "source": [
                  {
                    "type": "card",
                    "value": 0
                  },
                  {
                    "type": "preset",
                    "value": "preset_code"
                  }
                ],
                "values": [
                  {
                    ".landing-block-node-title@0": "First Card",
                    ".landing-block-node-title@1": "Card from Preset"
                  }
                ]
              }
            },
            "auth": "**put_access_token_here**"
          }' \
          "https://**put.your-domain-here**/rest/landing.block.updateCards.json"
        
try
        {
        	const response = await $b24.callMethod(
        		'landing.block.updateCards',
        		{
        			lid: 311,
        			block: 6058,
        			data: {
        				'.landing-block-card': {
        					source: [
        						{
        							type: 'card',
        							value: 0
        						},
        						{
        							type: 'preset',
        							value: 'preset_code'
        						}
        					],
        					values: [
        						{
        							'.landing-block-node-title@0': 'First Card',
        							'.landing-block-node-title@1': 'Card from Preset'
        						}
        					]
        				}
        			}
        		}
        	);
        
        	const result = response.getData().result;
        	console.info(result);
        }
        catch (error)
        {
        	console.error(error);
        }
        
try {
            $response = $b24Service
                ->core
                ->call(
                    'landing.block.updateCards',
                    [
                        'lid' => 311,
                        'block' => 6058,
                        'data' => [
                            '.landing-block-card' => [
                                'source' => [
                                    [
                                        'type' => 'card',
                                        'value' => 0,
                                    ],
                                    [
                                        'type' => 'preset',
                                        'value' => 'preset_code',
                                    ],
                                ],
                                'values' => [
                                    [
                                        '.landing-block-node-title@0' => 'First Card',
                                        '.landing-block-node-title@1' => 'Card from Preset',
                                    ],
                                ],
                            ],
                        ],
                    ]
                );
        
            $result = $response
                ->getResponseData()
                ->getResult();
        
            echo 'Success: ' . var_export($result, true);
        } catch (Throwable $e) {
            error_log($e->getMessage());
            echo 'Error updating block cards: ' . $e->getMessage();
        }
        
BX24.callMethod(
            'landing.block.updateCards',
            {
                lid: 311,
                block: 6058,
                data: {
                    '.landing-block-card': {
                        source: [
                            {
                                type: 'card',
                                value: 0
                            },
                            {
                                type: 'preset',
                                value: 'preset_code'
                            }
                        ],
                        values: [
                            {
                                '.landing-block-node-title@0': 'First Card',
                                '.landing-block-node-title@1': 'Card from Preset'
                            }
                        ]
                    }
                }
            },
            function(result)
            {
                if (result.error())
                {
                    console.error(result.error());
                }
                else
                {
                    console.info(result.data());
                }
            }
        );
        
require_once('crest.php');
        
        $result = CRest::call(
            'landing.block.updateCards',
            [
                'lid' => 311,
                'block' => 6058,
                'data' => [
                    '.landing-block-card' => [
                        'source' => [
                            [
                                'type' => 'card',
                                'value' => 0,
                            ],
                            [
                                'type' => 'preset',
                                'value' => 'preset_code',
                            ],
                        ],
                        'values' => [
                            [
                                '.landing-block-node-title@0' => 'First Card',
                                '.landing-block-node-title@1' => 'Card from Preset',
                            ],
                        ],
                    ],
                ],
            ]
        );
        
        if (isset($result['error']))
        {
            echo 'Error: ' . $result['error_description'];
        }
        else
        {
            echo '<pre>';
            print_r($result['result']);
            echo '</pre>';
        }
        

Response Handling

HTTP Status: 200

{
            "result": true,
            "time": {
                "start": 1774525085,
                "finish": 1774525085.858169,
                "duration": 0.8581690788269043,
                "processing": 0,
                "date_start": "2026-03-26T14:38:05+02:00",
                "date_finish": "2026-03-26T14:38:05+02:00",
                "operating_reset_at": 1774525685,
                "operating": 0
            }
        }
        

Returned Data

Name
type

Description

result
boolean

Result of the card update. Returns true on successful execution

time
time

Information about the execution time of the request

Error Handling

HTTP Status: 400

{
            "error": "MISSING_PARAMS",
            "error_description": "Not enough call parameters, missing: data"
        }
        

Name
type

Description

error
string

String error code. It may consist of digits, Latin letters, and underscores

error_description
error_description

Textual description of the error. The description is not intended to be shown to the end user in its raw form

Possible Error Codes

Code

Description

MISSING_PARAMS

Required parameter lid, block, or data is missing

LANDING_NOT_EXIST

Page with identifier lid not found or not accessible to the current user

BLOCK_NOT_FOUND

Block with identifier block not found on page lid or not accessible in the draft of the page

ACCESS_DENIED

User does not have permission to edit the site

INCORRECT_AFFECTED

The server could not confirm that the changes were applied correctly. The error depends on server settings and is not related to the request parameters

Statuses and System Error Codes

HTTP Status: 20x, 40x, 50x

The errors described below may occur when calling any method.

Status

Code
Error Message

Description

500

INTERNAL_SERVER_ERROR
Internal server error

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

500

ERROR_UNEXPECTED_ANSWER
Server returned an unexpected response

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

503

QUERY_LIMIT_EXCEEDED
Too many requests

The request intensity limit has been exceeded

405

ERROR_BATCH_METHOD_NOT_ALLOWED
Method is not allowed for batch usage

The current method is not permitted for calls using batch

400

ERROR_BATCH_LENGTH_EXCEEDED
Max batch length exceeded

The maximum length of parameters passed to the batch method has been exceeded

401

NO_AUTH_FOUND
Wrong authorization data

Invalid access token or webhook code

400

INVALID_REQUEST
Https required

The HTTPS protocol is required for method calls

503

OVERLOAD_LIMIT
REST API is blocked due to overload

The REST API is blocked due to overload. This is a manual individual block; please contact Bitrix24 technical support to lift it

403

ACCESS_DENIED
REST API is available only on commercial plans

The REST API is only available on commercial plans

403

INVALID_CREDENTIALS
Invalid request credentials

The user associated with the access token or webhook used to call the method lacks the necessary permissions

404

ERROR_MANIFEST_IS_NOT_AVAILABLE
Manifest is not available

The manifest is not available

403

insufficient_scope
The request requires higher privileges than provided by the webhook token

The request requires higher privileges than those provided by the webhook token

401

expired_token
The access token provided has expired

The provided access token has expired

403

user_access_error
The user does not have access to the application

The user does not have access to the application. This means that the application is installed, but the portal administrator has restricted access to this application to specific users only

500

PORTAL_DELETED
Portal was deleted

The public part of the site is closed. To open the public part of the site on an on-premise installation, disable the "Temporary closure of the public part of the site" option. Path to the setting: Desktop > Settings > Product Settings > Module Settings > Main Module > Temporary closure of the public part of the site

Continue Learning